package daikon.inv.binary.twoSequence;

import daikon.VarInfo;
import daikon.util.VCCSplitter;
import daikon.util.VCCSplitter.ArrayVarInfo;

abstract class LexicalAnnotationBuilder {

	private LexicalAnnotationBuilder() {
	}

	public static String lexicalGreaterThan(VarInfo a, VarInfo b) {
		return lessThan(b, a);
	}

	public static String lexicalGreaterEqual(VarInfo a, VarInfo b) {
		return lessThan(b, a) + " || " + equal(a, b);
	}

	public static String lexicalLessThan(VarInfo a, VarInfo b) {
		return lessThan(a, b);
	}

	public static String lexicalLessEqual(VarInfo a, VarInfo b) {
		return lessThan(a, b) + " ||" + equal(a, b);
	}

	private static String equal(VarInfo var1, VarInfo var2) {
		ArrayVarInfo array1 = VCCSplitter.getArrayVarInfo(var1);

		ArrayVarInfo array2 = VCCSplitter.getArrayVarInfo(var2);

		String len_array1 = String.format("(%s-%s)", array1.upper_bound,
				array1.lower_bound);
		String len_array2 = String.format("(%s-%s)", array2.upper_bound,
				array2.lower_bound);

		String equalArrays = String
				.format("((%s==%s) && (\\forall int i ; 0<=i && i<%s ==>%s[%s+i]==%s[%s+i]))",
						len_array1, len_array2, len_array1, array1.array_name,
						array1.lower_bound, array2.array_name,
						array2.lower_bound);

		return equalArrays;
	}

	private static String lessThan(VarInfo var1, VarInfo var2) {
		ArrayVarInfo array1 = VCCSplitter.getArrayVarInfo(var1);

		ArrayVarInfo array2 = VCCSplitter.getArrayVarInfo(var2);

		String len_array1 = String.format("(%s-%s)", array1.upper_bound,
				array1.lower_bound);
		String len_array2 = String.format("(%s-%s)", array2.upper_bound,
				array2.lower_bound);

		// subset
		String subsetArray = String
				.format("((%s<%s) && (\\forall int i; 0<=i && i<%s ==> %s[%s+i]==%s[%s+i]))",
						len_array1, len_array2, len_array1, array1.array_name,
						array1.lower_bound, array2.array_name,
						array2.lower_bound);

		// lessThan
		String lessThan = String
				.format("(\\exists int i; 0<=i && i<%s && i<%s && %s[%s+i]<%s[%s+i] && (\\forall int j ; 0<=j && j<i ==> %s[%s+j]==%s[%s+j]))",
						len_array1, len_array2, array1.array_name,
						array1.lower_bound, array2.array_name,
						array2.lower_bound, array1.array_name,
						array1.lower_bound, array2.array_name,
						array2.lower_bound);

		String vcc_str = subsetArray + " || " + lessThan;
		return vcc_str;
	}

}
