package daikon2;

public final class RuntimePredicates {

	/**
	 * Returns ==0 if some element in the arr is not equal to elt.
	 * 
	 * Returns >0 if all elements in arr is equal to elt.
	 * 
	 * Returns -1 if the arr is null
	 * 
	 * <code>eltsNotEqual(arr,elt)>0</code> iff all elements in the array are
	 * not equal to elt
	 * 
	 * @param arr
	 *            an integer array
	 * @param elt
	 *            an element to search within the array
	 * 
	 * @return a distance to this predicate
	 */
	// invariant \forall int i ; to+1<=i && i <=a_length-1 ==> a[i]!=a_length-1
	public static int eltsNotEqual(int[] arr, int elt) {

		int ret_val = Integer.MAX_VALUE;

		if (arr == null) {
			return -1;
		}

		for (int i = 0; i < arr.length; i++) {
			if (arr[i] == elt) {
				return 0;
			} else {
				int new_distance = Math.abs(arr[i] - elt);
				ret_val = Math.min(ret_val, new_distance);
			}
		}
		return ret_val;
	}
	
	
	public static int eltsNotEqual2(int[] arr, int elt) {

		int ret_val = Integer.MAX_VALUE;

		if (arr == null) {
			return -1;
		}

		for (int i = 0; i < arr.length; i++) {
			if (arr[i] == elt) {
				return 0;
			} else {
				int new_distance = Math.abs(arr[i] - elt);
				ret_val = Math.min(ret_val, new_distance);
			}
		}
		return ret_val;
	}
}
