#!/usr/bin/python

from gp import *
from ginpink import extension

logext = '.log'
datext = '.dat'


def read_dats(m, print_all):
    n = 1
    fn = m + '.iteration_' + str(n) + datext
    while os.path.exists(fn):
        n += 1
        fn = m + '.iteration_' + str(n) + datext
    # Last valid iteration
    n -= 1
    fn = m + '.iteration_' + str(n) + datext
    if not os.path.exists(fn):
        print "No stored iteration for " + m
        sys.exit(0)
    mw = pickle.load(open(fn, 'rb'))
    print mw
    if print_all:
        print ""
        print "-----> All mutations follow"
        for i in range(n):
            print ""
            print "-----> All mutations of iteration " + str(i + 1) + " follow"
            for s in mw.mutations[i]:
                exec_text = s[0].text()
                jml_text = s[1].text()
                print exec_text + '   <--exec|JML-->  ' + s[1].text()


def table_up(m, ext):
    fn = m + ext
    if not os.path.exists(fn):
        print "No result file with name " + fn
        sys.exit(0)
    rows = list()
    with open(fn) as f:
        for line in f.readlines():
            cnt = line.strip().split(' ')
            if line.find('-----> Generated') == 0:
                rows.append((cnt[-1], cnt[10]))
            elif line.find('No mutations generated within a timeout of') == 0:
                rows.append((cnt[-2], str(0)))
            elif line.find('No mutations returned') == 0:
                rows.append((str(0), str(0)))
    res = '; '.join([' ; '.join(r + (' ',)) for r in rows])
    return m + ' ; ' + res
            


if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument('M', nargs=1, metavar='M', action='store', \
                        help='a fully qualified method name to be processed (reading ' + datext + ' files)')
    parser.add_argument('-t', '--table', dest='table', action='store',
                        help='print results from .%(dest)s file in CSV format')
    parser.add_argument('-a', '--all', dest='print_all', action='store_true',
                        help='print all new mutations generated in each iteration')
    args = parser.parse_args()
    m = args.M[0]
    if not args.table:
        read_dats(m, args.print_all)
    else:
        print table_up(m, '.' + args.table)
