package java3.lang3;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

import org.ginpink.daikon.SnapshotIntValue;
import org.ginpink.daikon.SnapshotNonNullReference;
import org.ginpink.eval.InstanceConstructor;

public final class IntegerConstructor implements InstanceConstructor {

	private static final String INT_VALUE = "intValue";
	private static final String JAVA3_LANG3_INTEGER = "java3.lang3.Integer";

	@Override
	public Object createInstance(SnapshotNonNullReference ref) {
		if (!ref.getCanonicalClassName().equals(JAVA3_LANG3_INTEGER))
			throw new java.lang.IllegalArgumentException();

		if (ref.getFieldValue(INT_VALUE) == null)
			throw new java.lang.IllegalStateException("Missing field "
					+ INT_VALUE
					+ " for a snapshot reference. Check dtrace file contents");

		if (!(ref.getFieldValue(INT_VALUE) instanceof SnapshotIntValue))
			throw new java.lang.IllegalArgumentException();

		SnapshotIntValue snap_int_value = (SnapshotIntValue) ref
				.getFieldValue(INT_VALUE);

		int intValue = snap_int_value.intValue();

		ClassLoader class_loader = ClassLoader.getSystemClassLoader();

		try {
			Class<?> clazz = class_loader.loadClass(JAVA3_LANG3_INTEGER);
			Constructor<?> constructor = clazz.getConstructor(int.class);
			Object concrete_value = constructor.newInstance(intValue);
			ref.setConcreteValue(concrete_value);
			return concrete_value;

		} catch (ClassNotFoundException e) {
			throw new java.lang.RuntimeException("Could not load class for "
					+ JAVA3_LANG3_INTEGER);
		} catch (SecurityException e) {
			throw new java.lang.RuntimeException("Expecting "
					+ JAVA3_LANG3_INTEGER
					+ "  has a public constructor with argument int", e);

		} catch (NoSuchMethodException e) {
			throw new java.lang.RuntimeException("Expecting "
					+ JAVA3_LANG3_INTEGER
					+ " has a public constructor with argument int", e);
		} catch (java.lang.IllegalArgumentException e) {
			throw new java.lang.RuntimeException(e);
		} catch (InstantiationException e) {
			throw new java.lang.RuntimeException(e);
		} catch (IllegalAccessException e) {
			throw new java.lang.RuntimeException(e);
		} catch (InvocationTargetException e) {
			throw new java.lang.RuntimeException(e);
		}

	}

	@Override
	public String getClassName() {
		return JAVA3_LANG3_INTEGER;
	}

}
