package org.ginpink.eval;

import java.util.List;

import org.ginpink.LoopInvariantMethod;
import org.ginpink.daikon.GinPinkProcessorObserver;
import org.ginpink.daikon.Snapshot;

public final class JavaHeapEvaluator implements GinPinkProcessorObserver {

	private final List<LoopInvariantMethod> loopInvariantMethods;

	public JavaHeapEvaluator(List<LoopInvariantMethod> loopInvariantMethods) {
		this.loopInvariantMethods = loopInvariantMethods;
	}

	@Override
	public void notifyNewSnapshot(Snapshot snapshot) {
		JavaHeapBuilder javaheapBuilder = new JavaHeapBuilder();
		javaheapBuilder
				.registerInstanceConstructor(new java2.lang2.IntegerConstructor());
		javaheapBuilder
				.registerInstanceConstructor(new java3.lang3.IntegerConstructor());
		JavaHeap javaheap = javaheapBuilder.buildJavaHeap(snapshot);
		for (LoopInvariantMethod loopInvariantMethod : this.loopInvariantMethods) {

			String snapshot_classname = snapshot.getClassName();
			String snapshot_methodname = snapshot.getMethodName();

			String loop_classname = loopInvariantMethod.getClassName();
			String loop_methodname = loopInvariantMethod.getMethodName();
			if (snapshot_classname.equals(loop_classname)
					&& snapshot_methodname.equals(loop_methodname)) {
				loopInvariantMethod.checkInvariants(javaheap);
			}
		}

	}
}
