package org.ginpink.expr;

public final class JIntegerConstant extends JConstant {

	private final int intValue;
	
	public JIntegerConstant(int intValue) {
		super(true);
		this.intValue = intValue;
	}

	public int intValue() {
		return intValue;
	}

	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + intValue;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		JIntegerConstant other = (JIntegerConstant) obj;
		if (intValue != other.intValue)
			return false;
		return true;
	}
}
