package org.ginpink.expr;

public final class JLongConstant extends JConstant {

	private final long longValue;

	public JLongConstant(long longValue) {
		super(true);
		this.longValue = longValue;
	}

	public long longValue() {
		return longValue;
	}

	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + (int) (longValue ^ (longValue >>> 32));
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		JLongConstant other = (JLongConstant) obj;
		if (longValue != other.longValue)
			return false;
		return true;
	}

}
