package org.ginpink.expr;

public final class JNullExpr extends JExpr {

	private static JNullExpr singleton = null;

	private JNullExpr() {
	}

	public static JNullExpr getNullExpr() {
		if (singleton == null) {
			singleton = new JNullExpr();
			singleton.setType(JType.NULL_TYPE);
		}
		return singleton;
	}

	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}

}
