package org.ginpink.expr;

public final class JStringLiteral extends JConstant {

	private final String stringLiteral;

	public JStringLiteral(String stringLiteral) {
		super(true);
		this.stringLiteral = stringLiteral;
	}

	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}

	public String getStringLiteral() {
		return stringLiteral;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((stringLiteral == null) ? 0 : stringLiteral.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		JStringLiteral other = (JStringLiteral) obj;
		if (stringLiteral == null) {
			if (other.stringLiteral != null)
				return false;
		} else if (!stringLiteral.equals(other.stringLiteral))
			return false;
		return true;
	}

}
