package org.ginpink.expr;

public final class JUnaryOperation extends JOperation {

	public JUnaryOperation(JOperator operator, JExpr expr) {
		this.operator = operator;
		this.expr = expr;
	}

	private final JOperator operator;
	private final JExpr expr;

	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}

	public JOperator getOperator() {
		return operator;
	}

	public JExpr getExpr() {
		return expr;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((expr == null) ? 0 : expr.hashCode());
		result = prime * result
				+ ((operator == null) ? 0 : operator.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		JUnaryOperation other = (JUnaryOperation) obj;
		if (expr == null) {
			if (other.expr != null)
				return false;
		} else if (!expr.equals(other.expr))
			return false;
		if (operator != other.operator)
			return false;
		return true;
	}

}
