package org.ginpink.expr;

public final class JVar extends JExpr {

	private final String variable_name;

	public JVar(String variable_name) {
		this.variable_name = variable_name;
	}

	@Override
	public <T> T accept(JExprVisitor<T> v) {
		return v.visit(this);
	}

	public String getVarName() {
		return variable_name;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((variable_name == null) ? 0 : variable_name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		JVar other = (JVar) obj;
		if (variable_name == null) {
			if (other.variable_name != null)
				return false;
		} else if (!variable_name.equals(other.variable_name))
			return false;
		return true;
	}

}
